Translate

quarta-feira, 28 de março de 2012

VBA: Criar uma polilinha e rodar em Autocad, GstarCad e ZwCad

Esta rotina em VBA mostra como podemos construir um polígono, neste caso um triângulo e por fim rodamos com um basepoint (1,2,0) e ângulo de 45graus.


Para Autocad :

Sub Rotate_Polilinha()

    Dim polilinha As Acadlwpolyline
    Dim ponto(0 To 5) As Double
    ponto(0) = 0: ponto(1) = 1
    ponto(2) = 2: ponto(3) = 1
    ponto(4) = 1: ponto(5) = 3
    Set polilinha = ThisDrawing.ModelSpace.AddLightWeightPolyline(ponto)
    polilinha.Closed = True
   
    Dim basePoint(0 To 2) As Double
    Dim Angle As Double
    basePoint(0) = 1: basePoint(1) = 2: basePoint(2) = 0
    Angle = 0.7853981
    polilinha.Rotate basePoint, Angle
  
    ZoomExtents

End Sub

Para GstarCad :

Sub Rotate_Polilinha()

    Dim polilinha As Gcadlwpolyline
    Dim ponto(0 To 5) As Double
    ponto(0) = 0: ponto(1) = 1
    ponto(2) = 2: ponto(3) = 1
    ponto(4) = 1: ponto(5) = 3
    Set polilinha = thisDrawing.ModelSpace.AddLightWeightPolyline(ponto)
    polilinha.Closed = True
   
    Dim basePoint(0 To 2) As Double
    Dim Angle As Double
    basePoint(0) = 1: basePoint(1) = 2: basePoint(2) = 0
    Angle = 0.7853981
    polilinha.Rotate basePoint, Angle
  
    ZoomExtents

End Sub

Para ZwCad : 

Sub Rotate_Polilinha()

    Dim polilinha As Zwcadlwpolyline
    Dim ponto(0 To 5) As Double
    ponto(0) = 0: ponto(1) = 1
    ponto(2) = 2: ponto(3) = 1
    ponto(4) = 1: ponto(5) = 3
    Set polilinha = ThisDocument.ModelSpace.AddLightWeightPolyline(ponto)
    polilinha.Closed = True
   
    Dim basePoint(0 To 2) As Double
    Dim Angle As Double
    basePoint(0) = 1: basePoint(1) = 2: basePoint(2) = 0
    Angle = 0.7853981
    polilinha.Rotate basePoint, Angle
  
    ZoomExtents

End Sub

Obrigado.

Boa programação

Sem comentários:

Enviar um comentário